SystemOrganization addCategory: #'Magritte-RealMemento'!

MACachedMemento subclass: #MARealMemento
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RealMemento'!

!MARealMemento commentStamp: 'kph 11/20/2007 06:11' prior: 0!
I cache values being read and written without touching the model. 

But unlike MACachedMemento I use a copy of the model in the cache, this enables model behaviour to work.

When committing changes, the modifications will be propagated to the model all at once.!

MARealMemento subclass: #MARealCheckedMemento
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RealMemento'!

!MARealCheckedMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:19'!
hasConflict
	"Answer ==true==, if there is an edit conflict."

	^ self hasChanged and: [ (self original =@ self pullRaw) not ]! !

!MARealCheckedMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:20'!
original
	^ original! !

!MARealCheckedMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:20'!
reset
	super reset.
	self setOriginal: self pullRaw! !

!MARealCheckedMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:20'!
setOriginal: aDictionary
	original := aDictionary! !

!MARealCheckedMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:21'!
validate
	self hasConflict
		ifFalse: [ ^ super validate ].
	self reset.
	MAConflictError
		description: self description
		signal: self description conflictErrorMessage! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 07:11'!
commit
 
	model commit: [ self push: self cache ].
	self reset! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:26'!
hasChanged
	"Answer ==true==, if the cached data is different to the data in the model."

	^ ((self pullRawFrom: self cache) =@ self pullRaw) not! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:40'!
hasChangedSinceSnapshot
	"Answer ==true==, if the cached data is different to the data in the model."

	^ ((self pullRawFrom: self cache) =@ (self snapshot))not ! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:39'!
makeSnapshot

	snapshot := self pullRawFrom: self cache! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:33'!
pull
	"Utitlity method to copies the model into a cache populating nil values with the defaults specified by the descriptions"

	| result |
	
	result := self model copyForRealMemento.
		
	result description do: [ :each |
		(result readUsing: each) ifNil: [ result write: each default using: each ].
  	].

	^ result ! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:25'!
pullRaw
	^ self pullRawFrom: self model! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:24'!
pullRawFrom: aModel
	| result |
	result := Dictionary new.
	self description do: [ :each |
		result at: each put: (aModel
			readUsing: each) ].
	^ result! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 07:13'!
push:  acache
 
	model := acache! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:15'!
readUsing: aDescription
	^ (self cache readUsing: aDescription)
		ifNil: [ aDescription default ]! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:41'!
snapshot

	^ snapshot! !

!MARealMemento methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 06:16'!
write: anObject using: aDescription
	self cache write: anObject using: aDescription! !

!MAElementDescription methodsFor: '*magritte-realmemento-override' stamp: 'kph 11/20/2007 07:51'!
default
	^ (self propertyAt: #default ifAbsent: [ self class defaultDefault ]) yourself
 ! !
